##############################################################################
# Copyright (c) 2004-2005 Black Rock City, LLC
# Copyright (c) 2004-2005 ObjectRealms, LLC
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
##############################################################################
"""
$Id: relations.py 20200 2005-05-15 09:06:04Z rob $
"""

from Products.Archetypes.ReferenceEngine import Reference


class TeamMembershipRelation( Reference ):
    """
    Relationship Object Between a Member and their Membership within a Team
    """

    relationship = 'Team Membership Relation'

    def beforeSourceDeleteInformTarget(self):
        """When a member is deleted we want to delete their
        memberships as well"""
        tObj = self.getTargetObject()
        parent = tObj.aq_inner.aq_parent
        parent._delObject(tObj.id)


class TeamSpaceTeamRelation( Reference ):
    """
    Relationship Object Between a Team and a TeamSpace
    """

    relationship = 'TeamSpace Team Relation'


class TeamRosterTeamRelation( Reference ):
    """
    Relationship Object Between a Team and a TeamRoster
    """

    relationship = 'TeamRoster Team Relation'


class TeamContentTeamRelation( Reference ):
    """
    Relationship Object between a Team and a piece of content that is
    subject to that team's security policy
    """

    relationship = 'Team Content Team Relation'


